<?php
/**
* CB Noah's Classified My Ads PLUGIN - VERSION 1.3
* Author: barnett ted@contemplatedesign.com
*
* DESCRIPTION
* Plugin to display a member's Classified Ads from Noah's Classified in Community Builder
*
* THIS PLUGIN HAS BEEN TESTED WITH COMMUNITY BUILDER VERSION 1.0.1,
* JOOMLA 1.0.10 AND SMF 1.1 RC3
*
* LICENSE: GPL/GNU (and any other acronym that means 'it's free, do what you want')
*
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class getNoahMyAdsTab extends cbTabHandler {

  function getNoahMyAdsTab() {
		$this->cbTabHandler();
	}

	function getDisplayTab($tab,$user,$ui) {

		global $database, $mosConfig_live_site, $mosConfig_absolute_path;
        global $mosConfig_lang, $mosUser, $my;
		 
		if($tab->description != null) $return .= "\t\t<div class=\"tab_Description\">".unHtmlspecialchars(getLangDefinition($tab->description))."</div>\n"; 
		 
		//Load Show Parameters into Array
		$show = array();
                $params 			= $this->params;
		$showcat		= $params->get('showcat', 0);
		if($showcat) $show['showcat']=$showcat;
		$showtitle		= $params->get('showtitle', 0);
		if($showtitle) $show['showtitle']=$showtitle;
		$showpic		= $params->get('showpic', 0);
		if($showpic) $show['showpic']=$showpic;
		$showcreate		= $params->get('showcreate', 0);
		if($showcreate) $show['showcreate']=$showcreate;
		$showactive		= $params->get('showactive', 0);
		if($showactive) $show['showactive']=$showactive;
		$showview		= $params->get('showview', 0);
		if($showview) $show['showview']=$showview;
		$showresp		= $params->get('showresp', 0);
		if($showresp) $show['showresp']=$showresp;
		$showexp		= $params->get('showexp', 0);
		if($showexp) $show['showexp']=$showexp;
		$showrenew		= $params->get('showrenew', 0);
		if($showrenew) $show['showrenew']=$showrenew;
		$showactions		= $params->get('showactions', 0);
		if($showactions) $show['showactions']=$showactions;
		asort($show);
		 
		// Load Display Parameters
                $hideAds                = $params->get('hideads', 0);
		$showfullCatName   	= $params->get('fullcat', 0);
        $sortcatEnabled		= $params->get('noah_SortCatEnabled', 0);
		$sortcolEnabled		= $params->get('noah_SortColEnabled', 0);
                $submitEnabled          = $params->get('SubmitAdEnabled', 0);
		$pagingEnabled		= $params->get('noah_PagingEnabled', 0);
		$entriesNumber		= $params->get('noah_EntriesPerPage', '10');
                $header_row             = $params->get('headercolor', '#ccc');
                $first_row              = $params->get('firstcolor', '#fff');
                $second_row             = $params->get('secondcolor', '#ddd');
                global $_POST;
                $cat_value = null;
		if (isset($_POST["noahmyads_category"])) $cat_value = cbGetEscaped($_POST["noahmyads_category"]);
		$pagingParams 		= $this->_getPaging(array("noahmyads_category" => $cat_value),array("noahmyads_"));

                //Hide Ads for outside users
                if ($hideAds && ($my->id != $user->id)) {
                      $return .= "<br /><div class=\"sectiontableheader\" style=\"text-align:left;width:95%;\">";
		      $return .= _UE_NOAH_HIDEADS;
		      $return .= "</div>";
                      return $return;
                }
		
		// Find Noah Component ItemID
		$database->setQuery("select id from #__menu where link='index.php?option=com_noah' AND published=1");
        $comitem=$database->loadResult();

		
		// Is Owner allowed to Modify Ads
		$database->setQuery("select settings_allowModify from #__classifieds_globalsettings");
        $allowModify=$database->loadResult();
		
		// Only Show Approved Ads to Visitors
		$isVisitor=null;
		if($my->id != $user->id) $isVisitor="\n AND a.active=1";

		// narrow results by specific category if selected
        $specificCategory=null;
		if($pagingParams["noahmyads_category"] && $sortcatEnabled) $specificCategory="\n AND a.cid=".$pagingParams["noahmyads_category"];

		// select only CB user's ads
		$where = "\n WHERE a.ownerId=". $user->id;
		
		// construct where statement
		$where .= $isVisitor . $specificCategory;
		
		// Paging Limit
		if ($pagingEnabled) {
	    	$query="SELECT count(*)"
	           		. "\n FROM #__classifieds_advertisement AS a"
	        	    . $where;
			$database->setQuery($query);
	        $total = $database->loadResult();
	        if (!is_numeric($total)) $total = 0;
	        $userHasPosts = ($total > 0);
	        if ($pagingParams["noahmyads_limitstart"] === null) $pagingParams["noahmyads_limitstart"] = "0";
	        if ($entriesNumber > $total) $pagingParams["noahmyads_limitstart"] = "0";
	   	} else {
	        $pagingParams["noahmyads_limitstart"] = "0";
	    }
		
		// Column Sort Selected
	    switch ($pagingParams["noahmyads_sortby"]) {
	  	  	case "title":
				$order = "a.title ASC, a.creationtime DESC";
				break;
			case "title2":
				$order = "a.title DESC, a.creationtime DESC";
				break;
			case "veiws":
				$order = "a.clicked ASC, a.creationtime DESC";
				break;
			case "veiws2":
				$order = "a.clicked DESC, a.creationtime DESC";
				break;
			case "category":
				$order = "c.name ASC, a.creationtime DESC";
				break;
			case "category2":
				$order = "c.name DESC, a.creationtime DESC";
				break;
			case "approved":
				$order = "a.active ASC, a.creationtime DESC";
				break;
			case "renew":
				$order = "a.renewalNum DESC, a.creationtime DESC";
				break;
			case "response":
				$order = "a.responded ASC, a.creationtime DESC";
				break;
			case "response2":
				$order = "a.responded DESC, a.creationtime DESC";
				break;
			case "expire":
				$order = "a.expirationTime ASC, a.creationtime DESC";
				break;
			case "expire2":
				$order = "a.expirationTime DESC, a.creationtime DESC";
				break;
			case "created":
				$order = "a.creationtime ASC";
				break;
			case "created2":
			default:
				$order = "a.creationtime DESC";
				break;
	    }
		
		// Main Query
		$query = "SELECT a.id, a.title, a.cid, a.creationtime, c.wholeName, c.name,"
		. "\n a.active, a.clicked, a.picture, a.responded, a.ownerId, a.expirationTime, a.renewalNum"
		. "\n FROM #__classifieds_advertisement AS a"
		. "\n LEFT JOIN #__classifieds_classifiedscategory AS c ON a.cid=c.id"
		. $where
		. "\n ORDER BY ".$order
                . "\n LIMIT ".($pagingParams["noahmyads_limitstart"]?$pagingParams["noahmyads_limitstart"]:"0").",".$entriesNumber;
	    $database->setQuery( $query );
		$items = $database->loadObjectList();

		// Insert Submit New Ad Code
		if(($my->id == $user->id) && $submitEnabled) {
			$query = "SELECT a.id AS id, "
			. "\n a.wholeName AS name "
			. "\n FROM #__classifieds_classifiedscategory AS a "
			. "\n WHERE (a.accesspost <= ". $my->gid .") AND "
			. "\n (a.allowAd = 1)"
			. "\n ORDER BY a.wholeName"
			;
			
			$database->setQuery( $query );
			$submitcats = $database->loadObjectlist();
			
			if(count($submitcats) > 0) {
                                $return .= "<div class=\"sectiontableheader\" style=\"text-align:left;padding-left:0px;padding-right:0px;margin:0px 0px 10px 0px;height:auto;width:100%;\">";
			        $return .= "<div class=\"sectiontableheader\" style=\"float:left;\">"._UE_NOAH_SUBMIT."</div> ";
	
				$noah_url = "index.php?option=com_noah&Itemid=".$comitem."&v=g&method=create_form&list=advertisement&cid=";
				$return .= "<script type=\"text/JavaScript\"> "
						. "\n <!-- "
						. "\n function MM_jumpMenu(targ,selObj,restore){ //v3.0 "
					  	. "\n eval(targ+\".location='\"+selObj.options[selObj.selectedIndex].value+\"'\"); "
					  	. "\n if (restore) selObj.selectedIndex=0; "
						. "\n } "
						. "\n function MM_findObj(n, d) { //v4.01 "
					  	. "\n var p,i,x;  if(!d) d=document; if((p=n.indexOf(\"?\"))>0&&parent.frames.length) { "
					    . "\n d=parent.frames[n.substring(p+1)].document; n=n.substring(0,p);} "
					  	. "\n if(!(x=d[n])&&d.all) x=d.all[n]; for (i=0;!x&&i<d.forms.length;i++) x=d.forms[i][n]; "
						. "\n for(i=0;!x&&d.layers&&i<d.layers.length;i++) x=MM_findObj(n,d.layers[i].document); "
						. "\n if(!x && d.getElementById) x=d.getElementById(n); return x; "
						. "\n } "
						. "\n function MM_jumpMenuGo(selName,targ,restore){ //v3.0 "
					  	. "\n var selObj = MM_findObj(selName); if (selObj) MM_jumpMenu(targ,selObj,restore); "
						. "\n } "
						. "\n //--> "
						. "\n </script>"
						;
				$return .= "<form name=\"submitForm\" id=\"submitForm\"><div style=\"float:right;\">";
				
				foreach($submitcats as $cat) {
				$submit_url = sefRelToAbs($noah_url . $cat->id);
				$submit[] = mosHTML::makeOption( $submit_url, $cat->name );
				}
				
				$return .= mosHTML::selectList( $submit, 'submit', 'class="inputbox" size="1"', 'value', 'text', '' );
				$return .= "<input type=\"button\" name=\"submitad\" value=\""._UE_NOAH_SUBMIT."\" onclick=\"MM_jumpMenuGo('submit','parent',0)\" />";
				$return .= "</div></form>";
				$return .= "<br /><div style=\"clear:both;\">&nbsp;</div><hr /></div>";
			}
		}
		
		// Insert Category Sort Code
		if($sortcatEnabled) {
		    
			$base_url = $this->_getAbsURLwithParam($pagingParams, "userProfile", false, array("noahmyads_category","noahmyads_limitstart"));
			$CatList .= "<form action=\"".sefRelToAbs($base_url)."\" name=\"CatSort\" method=\"post\"><div style=\"float:right;\" >";
			
			// Currently Selected Category
			$selected = array();
			$selected[] = mosHTML::makeOption( $pagingParams["noahmyads_category"] );

                        // All Categories Option
                        $preload = array();
                        $preload[] = mosHTML::makeOption( '0', 'All Categories' );
						
			$query = "SELECT a.id AS id, "
			. "\n a.up AS parent,  a.name  AS name "
			. "\n FROM #__classifieds_classifiedscategory AS a "
			. "\n WHERE (a.accessview <= ". $my->gid .") "
			. "\n ORDER BY a.name"
			;
			
			$database->setQuery( $query );
			$viewcats = $database->loadObjectlist();
					
			$src_id = 0;  // parent level to start with
			$CatList .= mosHTML::treeSelectList( &$viewcats, $src_id, $preload, 'noahmyads_category', 'class="inputbox" size="1" onchange="document.CatSort.submit();"', 'value', 'text', $selected );			

			$CatList .= "</div></form>";
		}

		// If user has Ads
		if(count($items) > 0) {
			$return .= "<br /><div class=\"sectiontableheader\" style=\"text-align:left;padding-left:0px;padding-right:0px;margin:0px 0px 10px 0px;height:auto;width:100%;\">";
			$return .= "<div class=\"sectiontableheader\" style=\"float:left;\">"._UE_NOAH_TABTITLE."</div> ";
			$return .= $CatList;
			$return .= "<br /><div style=\"clear:both;\">&nbsp;</div>";
            $return .= "<table cellpadding=\"5\" cellspacing=\"0\" border=\"0\" class=\"sectiontable\" style=\"margin:0px;padding:0px;width:100%;text-align:center;\">";
            $return .= "<tr class=\"sectiontableheader\" bgcolor=\"". $header_row ."\">";
			foreach ($show as $key => $val) {
			   //echo "$key = $val\n";
                            $sortfield = "";
			    switch ($key) {
					case "showcat":
                                                if ($sortcolEnabled) {
                                                        $sortfield = $this->_writeSortByLink($pagingParams,"noahmyads_","category",_UE_NOAH_ASC) . $this->_writeSortByLink($pagingParams,"noahmyads_","category2",_UE_NOAH_DESC);
                                                }
						$return .= "<th>". _UE_NOAH_CATEGORY . "<br />" . $sortfield . "</th>";
						break;
					case "showtitle": 
                                                if ($sortcolEnabled) {
                                                        $sortfield = $this->_writeSortByLink($pagingParams,"noahmyads_","title",_UE_NOAH_ASC) . $this->_writeSortByLink($pagingParams,"noahmyads_","title2",_UE_NOAH_DESC);
                                                } 
						$return .= "<th>". _UE_NOAH_TITLE . "<br />" . $sortfield ."</th>";
						break;
					case "showpic": 
						$return .= "<th>". _UE_NOAH_PICTURE ."</th>";
						break;
					case "showcreate":
                                                if ($sortcolEnabled) {
                                                        $sortfield = $this->_writeSortByLink($pagingParams,"noahmyads_","created",_UE_NOAH_ASC) . $this->_writeSortByLink($pagingParams,"noahmyads_","created2",_UE_NOAH_DESC,true);
                                                }  
						$return .= "<th>". _UE_NOAH_CREATED . "<br />" . $sortfield ."</th>";
						break;
					case "showactive": 
                                                if ($sortcolEnabled) {
                                                        $sortfield = $this->_writeSortByLink($pagingParams,"noahmyads_","approved",_UE_NOAH_ASC);
                                                } 
						$return .= "<th>". _UE_NOAH_APPROVE . "<br />" . $sortfield ."</th>";
						break;
					case "showview":
                                                if ($sortcolEnabled) {
                                                        $sortfield = $this->_writeSortByLink($pagingParams,"noahmyads_","veiws",_UE_NOAH_ASC) . $this->_writeSortByLink($pagingParams,"noahmyads_","veiws2",_UE_NOAH_DESC);
                                                }  
						$return .= "<th>". _UE_NOAH_VIEWS . "<br />" . $sortfield ."</th>";
						break;
					case "showresp": 
                                                if ($sortcolEnabled) {
                                                        $sortfield = $this->_writeSortByLink($pagingParams,"noahmyads_","response",_UE_NOAH_ASC) . $this->_writeSortByLink($pagingParams,"noahmyads_","response2",_UE_NOAH_DESC);
                                                }
						$return .= "<th>". _UE_NOAH_RESPOND . "<br />" . $sortfield ."</th>";
						break;
					case "showexp": 
                                                if ($sortcolEnabled) {
                                                        $sortfield = $this->_writeSortByLink($pagingParams,"noahmyads_","expire",_UE_NOAH_ASC) . $this->_writeSortByLink($pagingParams,"noahmyads_","expire2",_UE_NOAH_DESC);
                                                }
						$return .= "<th>". _UE_NOAH_EXPIRE . "<br />" . $sortfield ."</th>";
						break;
					case "showrenew": 
                                                if ($sortcolEnabled) {
                                                        $sortfield = $this->_writeSortByLink($pagingParams,"noahmyads_","renew",_UE_NOAH_DESC);
                                                }
						$return .= "<th>". _UE_NOAH_RENEW . "<br />" . $sortfield ."</th>";
						break;
					case "showactions": 
						if($my->id == $user->id) {
							$return .= "<th>". _UE_NOAH_ACTIONS ."</th>";
						}
						break;
				}
			}
			$return .= "</tr>";
			
			// Loop through each Ad
                        $i = 0;
			foreach($items as $item) {
                                if($i > 0){
                                     $row_color = $second_row;
                                     $i = 0; 
                                } else {
                                     $row_color = $first_row;
                                     $i++;
                                }
				$return .= "<tr bgcolor=\"". $row_color ."\">";
	            foreach ($show as $key => $val) {
				   //echo "$key = $val\n";
				    switch ($key) {
			  	  		case "showcat": 
							$cat_url = "index.php?option=com_noah&Itemid=".$comitem."&v=g&method=showhtmllist&list=classifiedscategory&rollid=".$item->cid;
							if($showfullCatName) {
								$cat_name = $item->wholeName;
							} else {
								$cat_name = $item->name;
							}
							$return.= "<td><a href='". sefRelToAbs($cat_url) ."'>".$cat_name."</a></td>\n";
							break;
						case "showtitle":
							$ad_url = "index.php?option=com_noah&Itemid=".$comitem."&v=g&method=showdetails&list=advertisement&rollid=".$item->id;
							$return.= "<td><a href='". sefRelToAbs($ad_url) ."'>".$item->title."</a></td>\n";
							break;
						case "showpic":
							$ad_url = "index.php?option=com_noah&Itemid=".$comitem."&v=g&method=showdetails&list=advertisement&rollid=".$item->id;
							if($item->picture != '') {
								$pic_url = $mosConfig_live_site."/noah_pics/listings/".$item->id.".".$item->picture;
							} else {
								$pic_url = $mosConfig_live_site."/components/com_noah/i/no.png";
							}
							$return.= "<td><a href='". sefRelToAbs($ad_url) ."'><img src='". $pic_url ."' border='0' /></a></td>\n";
							break;
						case "showcreate":
                                                        $create_date = date(_UE_NOAH_TIME, $item->creationtime);
							$return.= "<td>". $create_date ."</td>\n";
							break;
						case "showactive":	
							$active_label = $item->active ? _UE_YES : _UE_NO;
							$return.= "<td>". $active_label ."</td>\n";
							break;
						case "showview":
							$return.= "<td>".$item->clicked."</td>\n";
							break;
						case "showresp":
							$return.= "<td>".$item->responded."</td>\n";
							break;
						case "showexp":
                                                        $exp_date = "";
                                                        if($item->expirationTime) $exp_date = date(_UE_NOAH_TIME, $item->expirationTime);
							$return.= "<td>". $exp_date ."</td>\n";
							break;
						case "showrenew":
							$return.= "<td>".$item->renewalNum."</td>\n";
							break;
						case "showactions":
							$del_url = "index.php?option=com_noah&Itemid=".$comitem."&v=g&method=delete_form&list=advertisement_my&id=".$item->id;
							$mod_url = "index.php?option=com_noah&Itemid=".$comitem."&v=g&method=modify_form&list=advertisement_my&id=".$item->id;
							if($my->id == $user->id) {
								if($allowModify){
									$return.= "<td><a href='".sefRelToAbs($mod_url)."'>". _UE_NOAH_MODIFY."</a><br /><a href='".$del_url."'>". _UE_NOAH_DELETE."</a></td>\n";
								} else {
									$return.= "<td><a href='".sefRelToAbs($del_url)."'>". _UE_NOAH_DELETE."</a></td>\n";
								}
							}
							break;
					}
				}
				$return .= "</tr>\n";	
			}
			$return .= "</table></div>";
	        if ($pagingEnabled && ($entriesNumber < $total)) {
	             $return .= "<div style='width:95%;text-align:center;'>"
	             .$this->_writePaging($pagingParams,"noahmyads_",$entriesNumber,$total)
	             ."</div>";
	        }
		}
		else {
			if ($pagingEnabled && $userHasPosts && $sortcatEnabled && $pagingParams["noahmyads_category"]) {
					 $return .= "<br /><div class=\"sectiontableheader\" style=\"text-align:left;width:95%;\">";
					 $return .= $CatList;
		             $return .= "</div>";
					 $return .= "<br />".sprintf(_UE_NOAH_FOUNDADS, 0);
            } else {
		 			 $return .= "<br /><br /><div class=\"sectiontableheader\" style=\"text-align:left;width:95%;\">";
                                         if ($sortcatEnabled) $return .= $CatList;
					 $return .= _UE_NOAH_NOADS;
					 $return .= "</div>";
            }
		}
		
    return $return;
    }
}	// end class getSMFProfileTab

?>